package Spec;

import br.ufpe.abaco.compiler.*;
import br.ufpe.abaco.ParserGen.*;

public class TupleImplementation {

    CompiledSpecification spec;
    StandardOperators stan;

    public static void register(CompiledSpecification spec) {
	new TupleImplementation(spec);
    }

    TupleImplementation(CompiledSpecification spec) {

	this.spec = spec;
	stan = new StandardOperators(spec);

	Choice tupleParser = (Choice)spec.getProduction("_internalTuples2_");
	
	Sequencing prod;
	
	prod = new Sequencing();
	prod.add(spec.getProduction("tuple"));
	tupleParser.add(prod);
	
	prod = new Sequencing();
	prod.add(spec.getProduction("tuple"));
	prod.add(new ConstantString(","));
	prod.add(tupleParser);
	prod.setAction(StandardActions.makeTerm(stan.concatOp,2));
	tupleParser.add(prod);
	
	prod = new Sequencing();
	prod.add(new ConstantString("("));
	prod.add(tupleParser);
	prod.add(new ConstantString(")"));
  
	tupleParser = (Choice)spec.getProduction("_internalTuples_");
	tupleParser.add(prod);
	
	spec.insertNativeType("tuple", TupleTerm.class , tupleParser );

	spec.insertNativeImplementation("( _ , _ )",new NativeImplementation() {
		public Term evaluate(Term args[]) {
		    return TupleTerm.makeTuple(stan,args[0],args[1]);
		}
	    });


    }
}
